; draw.s

	GET	macros.s

	MACRO
$l	UWIMPN
$l	TEQ	r1,#1
	ORRNE	r0,r0,#&100
	SWINE	XOS_SpriteOp
	SWIEQ	XWimp_SpriteOp
	MEND

	AREA	|____draw_setdashpattern|, CODE, READONLY
	EXPORT	draw_setdashpattern
draw_setdashpattern

	SWI	&20100+23
	SWI	&20100+6

	SWI	&20000
	SWI	&20000
	SWI	&20000
	SWI	&20000

	SWI	&20000
	SWI	&20000
	SWI	&20000
	SWI	&20000

	MOV	r2,r1
	MOV	r1,#242
	MOV	r0,#163
	SWI	XOS_Byte
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|VB____draw_getpalette|, CODE, READONLY
	EXPORT	|_draw_getpalette|
|_draw_getpalette|

	LDR	r1,=draw_wimppalette
	SWI	XWimp_ReadPalette
	MOV	r2,#15
	MOV	r0,#0
correct_palette
	STRB	r0,[r1,r2,LSL#2]
	SUBS	r2,r2,#1
	BPL	correct_palette
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____draw_wimppalette|, NOINIT
	EXPORT	draw_wimppalette
draw_wimppalette

	%	20*4

	AREA	|VB____draw_getmode|, CODE, READONLY
	EXPORT	|_draw_getmode|
|_draw_getmode|

	LDR	r12,=draw_shiftx
	LDR	r3,=draw_colours
	MOV	r1,#3
	MOV	r0,#-1
	SWI	XOS_ReadModeVariable
	STR	r2,[r3,#0]
	MOV	r1,#4
	SWI	XOS_ReadModeVariable
	MOV	r1,#1
	STR	r2,[r12,#0]
	MOV	r2,r1,LSL r2
	STR	r2,[r3,#4]
	MOV	r1,#5
	SWI	XOS_ReadModeVariable
	MOV	r1,#1
	STR	r2,[r12,#4]
	MOV	r2,r1,LSL r2
	STR	r2,[r3,#8]
	MOV	r1,#11
	SWI	XOS_ReadModeVariable
	LDR	r1,[r3,#4]
	MLA	r1,r2,r1,r1
	STR	r1,[r3,#12]
	MOV	r1,#12
	SWI	XOS_ReadModeVariable
	LDR	r1,[r3,#8]
	MLA	r1,r2,r1,r1
	STR	r1,[r3,#16]
	MOV	r1,#9
	SWI	XOS_ReadModeVariable
	STR	r2,[r3,#20]
	MOV	r0,#135
	SWI	XOS_Byte
	STR	r2,[r3,#24]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	LTORG

	AREA	|VB____draw_setorigin|, CODE, READONLY
	EXPORT	|_draw_setorigin|
|_draw_setorigin|

	LDR	r2,=|__draw_localx|
	STMIA	r2,{r0,r1}
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	LTORG

	AREA	|____draw_plot|, CODE, READONLY
	EXPORT	draw_plot
draw_plot

	TST	r0,#4						; Is it absolute?
	BEQ	dp_none						; Nope, so don't add origin
	LDR	r3,=|__draw_localx|
	LDR	r3,[r3]
	ADD	r1,r1,r3
	LDR	r3,=|__draw_localy|
	LDR	r3,[r3]
	ADD	r2,r2,r3					; If it is, add in the window offsets
dp_none	SWI	XOS_Plot
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|__draw_localdata|, COMMON, NOINIT
	EXPORT	|__draw_localx|
	EXPORT	|__draw_localy|
|__draw_localx|
	DCD	0
|__draw_localy|
	DCD	0

	EXPORT	draw_colours
draw_colours
	DCD	0

	EXPORT	draw_scalex
draw_scalex
	DCD	0

	EXPORT	draw_scaley
draw_scaley
	DCD	0

	EXPORT	draw_maxx
draw_maxx
	DCD	0

	EXPORT	draw_maxy
draw_maxy
	DCD	0

	EXPORT	draw_bpp
draw_bpp
	DCD	0

	EXPORT	draw_mode
draw_mode
	DCD	0

|__draw_localscales|
	DCD	0,0,0,0

|__draw_localcolourtrans|
	%	256

|__draw_tempworkspace|
	%	32

	EXPORT	draw_shiftx
draw_shiftx
	DCD	0

	EXPORT	draw_shifty
draw_shifty
	DCD	0


	AREA	|____sprite_getscalingp|, CODE, READONLY
	EXPORT	sprite_getscalingp
sprite_getscalingp

; r0 is ^ sprite
; r1 is ^ scaling
; r2 is ^ colour translation table
	STMFD	r13!,{r4-r7,lr}

	MOV	r6,r1
	MOV	r7,r2
	MOV	r1,r0
	MOV	r2,r0
	MOV	r0,#&200
	SWI	XWimp_ReadPixTrans
 [ arm32
	LDMFD	r13!,{r4-r7,pc}
 |
	LDMFD	r13!,{r4-r7,pc}^
 ]

	AREA	|____sprite_plotsprite|, CODE, READONLY
	EXPORT	sprite_plotsprite
sprite_plotsprite

	STMFD	r13!,{r4-r7,lr}
	LDR	r6,=|__draw_localscales|
	ADD	r7,r6,#16					; Point to draw_localcolourtrans
	MOV	r4,r3
	MOV	r3,r4
	MOV	r2,r1
	MOV	r1,r0
	TEQ	r1,#1
	MOVEQ	r0,#&100
	MOVNE	r0,#0
	SWI	XWimp_ReadPixTrans
 [ arm32
	LDMVSFD	r13!,{r4-r7,pc}				; Can't plot it
 |
	LDMVSFD	r13!,{r4-r7,pc}^				; Can't plot it
 ]
	LDR	r5,=|__draw_localx|
	LDMIA	r5,{r0,r5}
	ADD	r4,r4,r5
	ADD	r3,r3,r0					; Add origin
	MOV	r0,#52
	MOV	r5,#8
	UWIMPN
 [ arm32
	LDMFD	r13!,{r4-r7,pc}				; Plot it...
 |
	LDMFD	r13!,{r4-r7,pc}^				; Plot it...
 ]

	LTORG

	AREA	|____sprite_plotspriten|, CODE, READONLY
	EXPORT	sprite_plotspriten
sprite_plotspriten

	STMFD	r13!,{r4,r5,r14}
	MOV	r4,r3
	MOV	r3,r2
	MOV	r2,r1
	MOV	r1,r0
	MOV	r0,#34
	MOV	r5,#8
	UWIMPN
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	|____sprite_plotspritet|, CODE, READONLY
	EXPORT	sprite_plotspritet
sprite_plotspritet

	MOV	r12,r13
	STMFD	r13!,{r4-r7,r14}
	MOV	r4,r3
	MOV	r3,r2
	MOV	r2,r1
	MOV	r1,r0
	LDR	r6,=|__draw_localscales|
	RPARAM	r5,4
	STR	r5,[r6]
	RPARAM	r5,5
	STR	r5,[r6,#4]
	RPARAM	r5,6
	STR	r5,[r6,#8]
	RPARAM	r5,7
	STR	r5,[r6,#12]
	RPARAM	r7,8
	MOV	r5,#8
	MOV	r0,#52
	UWIMPN
 [ arm32
	LDMFD	r13!,{r4-r7,pc}
 |
	LDMFD	r13!,{r4-r7,pc}^
 ]

	LTORG

	AREA	|____sprite_plotspritep|, CODE, READONLY
	EXPORT	sprite_plotspritep
sprite_plotspritep

	STMFD	r13!,{r4-r7,lr}
	LDR	r6,=|__draw_localscales|
	ADD	r7,r6,#16					; Point to draw_localcolourtrans
	MOV	r4,r3
	MOV	r3,r4
	MOV	r2,r1
	MOV	r1,r0
	TEQ	r1,#1
	MOVEQ	r0,#&100
	MOVNE	r0,#0
	SWI	XWimp_ReadPixTrans
 [ arm32
	LDMVSFD	r13!,{r4-r7,pc}				; Can't plot it
 |
	LDMVSFD	r13!,{r4-r7,pc}^				; Can't plot it
 ]
;	LDR	r5,=|__draw_localx|
;	LDMIA	r5,{r0,r5}
;	ADD	r4,r4,r5
;	ADD	r3,r3,r0					; Add origin
	MOV	r0,#52
	MOV	r5,#8
	ORR	r0,r0,#256
	SWI	XOS_SpriteOp
 [ arm32
	LDMFD	r13!,{r4-r7,pc}				; Plot it...
 |
	LDMFD	r13!,{r4-r7,pc}^				; Plot it...
 ]

	LTORG

	AREA	|____draw_ecforigin|, CODE, READONLY
	EXPORT	draw_ecforigin
draw_ecforigin

	SWI	XOS_SetECFOrigin
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____draw_origin|, CODE, READONLY
	EXPORT	draw_origin
draw_origin

	SWI	&20100+29
	SWI	&20000
	MOV	r0,r0,LSR#8
	SWI	&20000
	MOV	r0,r1
	SWI	&20000
	MOV	r0,r0,LSR#8
	SWI	&20000
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____sprite_plotspritepn|, CODE, READONLY
	EXPORT	sprite_plotspritepn
sprite_plotspritepn

	STMFD	r13!,{r4,r5,r14}
	MOV	r4,r3
	MOV	r3,r2
	MOV	r2,r1
	MOV	r1,r0
	MOV	r0,#34
	MOV	r5,#8
	ORR	r0,r0,#256
	SWI	XOS_SpriteOp
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	|____sprite_plotspritept|, CODE, READONLY
	EXPORT	sprite_plotspritept
sprite_plotspritept

	MOV	r12,r13
	STMFD	r13!,{r4-r7,r14}
	MOV	r4,r3
	MOV	r3,r2
	MOV	r2,r1
	MOV	r1,r0
	LDR	r6,=|__draw_localscales|
	RPARAM	r5,4
	STR	r5,[r6]
	RPARAM	r5,5
	STR	r5,[r6,#4]
	RPARAM	r5,6
	STR	r5,[r6,#8]
	RPARAM	r5,7
	STR	r5,[r6,#12]
	RPARAM	r7,8
	MOV	r5,#8
	MOV	r0,#52
	ORR	r0,r0,#256
	SWI	XOS_SpriteOp
 [ arm32
	LDMFD	r13!,{r4-r7,pc}
 |
	LDMFD	r13!,{r4-r7,pc}^
 ]

	LTORG

	AREA	|____sprite_loadsprite|, CODE, READONLY
	EXPORT	sprite_loadsprite
sprite_loadsprite

	STMFD	r13!,{r4-r6,lr}
	MOV	r1,r0
	MOV	r0,#5
	SWI	XOS_File
	TEQ	r0,#1
 [ arm32
	LDMNEFD	r13!,{r4-r6,pc}
 |
	LDMNEFD	r13!,{r4-r6,pc}^
 ]
	MOV	r5,r1
	ADD	r0,r4,#4
	IMPORT	rmalloc
	BL	rmalloc
	TEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{r4-r6,pc}
 |
	LDMEQFD	r13!,{r4-r6,pc}^
 ]
	MOV	r6,r0
	STR	r4,[r0]
	ADD	r2,r0,#4
	MOV	r0,#255
	MOV	r3,#0
	MOV	r1,r5
	SWI	XOS_File
	MOV	r0,r6
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

	AREA	|____draw_fill|, CODE, READONLY
	EXPORT	draw_fill
draw_fill

	SWI	XDraw_Fill
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____draw_stroke|, CODE, READONLY
	EXPORT	draw_stroke
draw_stroke

	MOV	r12,r13
	STMFD	r13!,{r4-r6,lr}
	LDMIA	r12,{r4-r6}
	SWI	XDraw_Stroke
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

	AREA	|____draw_setcolour|, CODE, READONLY
	EXPORT	draw_setcolour
draw_setcolour

	STMFD	r13!,{r4,lr}
	MOV	r4,#0
	MOV	r3,#&100
	SWI	XColourTrans_SetGCOL
 [ arm32
	LDMFD	r13!,{r4,pc}
 |
	LDMFD	r13!,{r4,pc}^
 ]

	AREA	|____draw_setgcolcolour|, CODE, READONLY
	EXPORT	draw_setgcolcolour
draw_setgcolcolour

	STMFD	r13!,{r4,lr}
	MOV	r4,r1
	MOV	r3,#&100
	SWI	XColourTrans_SetGCOL
 [ arm32
	LDMFD	r13!,{r4,pc}
 |
	LDMFD	r13!,{r4,pc}^
 ]

	AREA	|____draw_findfont|, CODE, READONLY
	EXPORT	draw_findfont
draw_findfont

	STMFD	r13!,{r4,r5,lr}
	MOV	r4,#0
	MOV	r5,#0
	MOV	r3,r2
	MOV	r2,r1
	MOV	r1,r0
	SWI	XFont_FindFont
	MOVVS	r0,#-1
 [ arm32
	LDMFD	r13!,{r4,r5,pc}
 |
	LDMFD	r13!,{r4,r5,pc}^
 ]

	AREA	|____draw_losefont|, CODE, READONLY
	EXPORT	draw_losefont
draw_losefont

	SWI	XFont_LoseFont
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____draw_paintfont|, CODE, READONLY
	EXPORT	draw_paintfont
draw_paintfont

	STMFD	r13!,{r4,lr}
;	LDR	lr,=__draw_localx
;	LDMIA	lr,{r4,lr}
;	ADD	r3,r3,lr
;	ADD	r2,r2,r4
	MOV	r4,r3
	MOV	r3,r2
	MOV	r2,#2_100010000
	SWI	XFont_Paint
 [ arm32
	LDMFD	r13!,{r4,pc}
 |
	LDMFD	r13!,{r4,pc}^
 ]


	AREA	|____draw_setfontcolour|, CODE, READONLY
	EXPORT	draw_setfontcolour
draw_setfontcolour

	MOV	r3,#14
	SWI	XColourTrans_SetFontColours
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____draw_setfont|, CODE, READONLY
	EXPORT	draw_setfont
draw_setfont

	SWI	XFont_SetFont
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____draw_paintfontx|, CODE, READONLY
	EXPORT	draw_paintfontx
draw_paintfontx

	MOV	r12,r13
	STMFD	r13!,{r4-r6,lr}
	LDR	r6,[r12]
	MOV	r4,r3
	MOV	r3,r2
	LDR	r2,[r12,#4]
	ORR	r2,r2,#1<<6
	SWI	XFont_Paint
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

	AREA	|____draw_getspriteinfo|, CODE, READONLY
	EXPORT	draw_getspriteinfo
draw_getspriteinfo

	STMFD	r13!,{r1-r6,lr}
	MOV	r2,r0
	SUB	r1,r0,#4
	MOV	r0,#512+40
	SWI	XOS_SpriteOp
	LDMIA	r13!,{r0-r2}
	STR	r3,[r0]
	STR	r4,[r1]
	STR	r6,[r2]
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

	AREA	|____draw_getnamedspriteinfo|, CODE, READONLY
	EXPORT	draw_getnamedspriteinfo
draw_getnamedspriteinfo

; r0 is ^ sprite area
; r1 is ^ sprite name
; r2 is ^ return X
; r3 is ^ return Y
; !r13 is return MODE
; r13!4 is return mask

	MOV	r12,r13
	STMFD	r13!,{r2-r8,lr}
	MOV	r7,r0
	MOV	r8,r1
	MOV	r2,r1
	MOV	r1,r0
	TEQ	r1,#1
	MOVNE	r0,#256+40
	SWINE	XOS_SpriteOp
	MOVEQ	r0,#40
	SWIEQ	XWimp_SpriteOp
	LDMIA	r13!,{r0-r1}
	STR	r3,[r0]
	STR	r4,[r1]
	LDMIA	r12!,{r0}
	STR	r6,[r0]
	MOV	r1,r7
	MOV	r2,r8
	MOV	r0,#256
	ORR	r0,r0,#37
	MOV	r3,#-1
	SWI	XOS_SpriteOp
	LDMIA	r12!,{r1}
	TEQ	r3,#0
	MOVNE	r3,#1
	STR	r3,[r1]
 [ arm32
	LDMFD	r13!,{r4-r8,pc}
 |
	LDMFD	r13!,{r4-r8,pc}^
 ]

	AREA	|____draw_getmodevar|, CODE, READONLY
	EXPORT	draw_getmodevar
draw_getmodevar

	SWI	XOS_ReadModeVariable
	MOV	r0,r2
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____draw_selecttable|, CODE, READONLY
	EXPORT	draw_selecttable
draw_selecttable

	MOV	r12,r13
	STMFD	r13!,{r4,lr}
	LDR	r4,[r12]
	SWI	XColourTrans_SelectTable
 [ arm32
	LDMFD	r13!,{r4,pc}
 |
	LDMFD	r13!,{r4,pc}^
 ]

	AREA	|____draw_plotsprite|, CODE, READONLY
	EXPORT	draw_plotsprite
draw_plotsprite

; r0 is ^ sprite
; r1 is plot mode
; r2 is sx
; r3 is sy
;r12!0 is ^matrix
;r12!4 is ^ctrans

	MOV	r12,r13
	STMFD	r13!,{r4-r7,lr}

	MOV	r4,r3
	MOV	r3,r2
	MOV	r2,r0
	MOV	r5,r1
;	SUB	r0,r1,#4
	MOV	r1,#255
	MOV	r0,#52+512
;	ORR	r0,r0,#512
	LDMIA	r12,{r6,r7}
	SWI	XOS_SpriteOp
 [ arm32
	LDMFD	r13!,{r4-r7,pc}
 |
	LDMFD	r13!,{r4-r7,pc}^
 ]

	AREA	|____draw_plotsprite56|, CODE, READONLY
	EXPORT	draw_plotsprite56
draw_plotsprite56

; r0 is ^ sprite
; r1 is plot mode
; r2 is ^ matrix
; r3 is ^ ctrans
	STMFD	r13!,{r4-r7,lr}
	MOV	r7,r3
	MOV	r6,r2
	MOV	r5,r1
	MOV	r2,r0
;	SUB	r1,r0,#4
	MOV	r1,#255
	MOV	r0,#512+56
;	ORR	r0,r0,#512
	MOV	r3,#0
	MOV	r4,#0
	SWI	XOS_SpriteOp
 [ arm32
	LDMFD	r13!,{r4-r7,pc}
 |
	LDMFD	r13!,{r4-r7,pc}^
 ]

	AREA	|____draw_charscaled|, CODE, READONLY
	EXPORT	draw_charscaled
draw_charscaled

	STMFD	r13!,{r4,r6,lr}
	MOV	r6,r3
	MOV	r4,r2
	MOV	r3,r1
	MOV	r1,r0
	MOV	r0,#51
	SWI	XOS_SpriteOp
 [ arm32
	LDMFD	r13!,{r4,r6,pc}
 |
	LDMFD	r13!,{r4,r6,pc}^
 ]

	AREA	|____draw_setcharsize|, CODE, READONLY
	EXPORT	draw_setcharsize
draw_setcharsize

	SWI	&20100+23
	SWI	&20100+17
	SWI	&20100+7
	SWI	&20100+1
	CMP	r0,#0
	MOVLE	r0,#1
	SWI	&20000
	MOV	r0,r0,LSR#8
	SWI	&20000
	MOVS	r0,r1
	MOVLE	r0,#1
	SWI	&20000
	MOV	r0,r0,LSR#8
	SWI	&20000
	SWI	&20100
	SWI	&20100
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____draw_pchar|, CODE, READONLY
	EXPORT	draw_pchar
draw_pchar

	SWI	&20000
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____draw_gcol|, CODE, READONLY
	EXPORT	draw_gcol
draw_gcol

	SWI	XWimp_SetColour
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____sprite_plotrawp|, CODE, READONLY
	EXPORT	sprite_plotrawp
sprite_plotrawp

; r0 is ^ sprite
; r1 is x
; r2 is y
; r3 is ^ scaling table
; !r13 is ^ translation table

	MOV	r12,r13
	STMFD	r13!,{r4-r7,lr}
	LDR	r7,[r12]
	MOV	r6,r3
	MOV	r5,#8
	MOV	r4,r2
	MOV	r3,r1
	MOV	r2,r0
	MOV	r1,r0
	MOV	r0,#&234
	SWI	XOS_SpriteOp
 [ arm32
	LDMFD	r13!,{r4-r7,pc}
 |
	LDMFD	r13!,{r4-r7,pc}^
 ]

	AREA	|____draw_ploticon|, CODE, READONLY
	EXPORT	draw_ploticon
draw_ploticon

	IMPORT	poll_block

	MOV	r12,r13
	STMFD	r13!,{r4-r7,lr}
	LDR	lr,=poll_block+&c0
	LDMIA	r12,{r4,r5}
	LDMIA	r5,{r5-r7}
	STMIA	lr,{r0-r7}
	MOV	r1,lr
	SWI	XWimp_PlotIcon
 [ arm32
	LDMFD	r13!,{r4-r7,pc}
 |
	LDMFD	r13!,{r4-r7,pc}^
 ]

	AREA	|____sprite_spriteexists|, CODE, READONLY
	EXPORT	sprite_spriteexists
sprite_spriteexists

	STMFD	r13!,{r4-r6,lr}
	MOV	r2,r1
	MOV	r1,r0
	MOV	r0,#40
	UWIMPN
	MOVVS	r0,#0
	MOVVC	r0,#1
 [ arm32
	LDMFD	r13!,{r4-r6,pc}
 |
	LDMFD	r13!,{r4-r6,pc}^
 ]

	AREA	|____sprite_address|, CODE, READONLY
	EXPORT	sprite_address
sprite_address

	MOV	r2,r1
	MOV	r1,r0
	MOV	r0,#&18
	UWIMPN
	MOVVS	r0,#0
	MOVVC	r0,r2
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____draw_setmode|, CODE, READONLY
	EXPORT	draw_setmode
draw_setmode

	SWI	XWimp_SetMode
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____draw_redrawscreen|, CODE, READONLY
	EXPORT	draw_redrawscreen
draw_redrawscreen

	STMFD	r13!,{r4,lr}
	MOV	r0,#-1
	MOV	r1,#0
	MOV	r2,#0
	MOV	r3,#32768
	SUB	r3,r3,#1
	MOV	r4,r3
	SWI	XWimp_ForceRedraw
 [ arm32
	LDMFD	r13!,{r4,pc}
 |
	LDMFD	r13!,{r4,pc}^
 ]

	AREA	|____draw_mode0|, CODE, READONLY
	EXPORT	draw_mode0
draw_mode0

	SWI	&20100+22
	SWI	&20100+0
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	END
